; Copyright 1987  Unkel Software, Inc.
; callable library to handle IBM DACA
;
;  setuca(iadsta)            setup board at address iadsta
;  pcadsc(iadval())          return channel 0-3 into array ival
;  pcdasc(idaval())          send array ival to d/a
;  pcadda(iadval(),idaval()) sample a/d and send d/a
;  pc10ki(iarray,nsamp,      put nsamp values from Chan 0 into iarray
;               icount)      speed is icount*.9775E-6, 20<icount<255
;  pc10ko(iarray,nsamp,      put nsamp values from iarray out to d/a 0
;               icount)      speed is icount*.9775E-6, 20<icount<255
;  pcatod(istat,ivalue)      get a/d at istat immediately
;  pcdtoa(istat,ivalue)      single channel immediately
;  pcdgou(ivalue)            put value to digital output
;  pcdgin(ivalue)            get digital value
;  watica(nerr)              wait for counter overflow of counter 1
;  rdtica(ivalue)            return counter 1 value
;  sttica(idatt1,idatt2)     set up pacer clock
;  clint                     clear the interrupts
;  rdint(itint,icint,irint)  return the value of the interrupt flags
;  seint(ivalue)             set the interrupt register
;  st8253(icounter,          set icounter to run with
;         icontrol,              icontrol mode and load
;         icount)                icount into the counter register
         include sbrt.mac
         include daca.mac
data     segment  public 'data'
cdata    dw    0
icont    dw    0
icontr   dw    0
ictrl    db    0
icount   dw    0
istat    dw    0
ivalue   dw    0
idatt1   dw    0
idatt2   dw    0
idum     dw    0
iad0     dw    0  ; local storage for a/d data
iad1     dw    0  ;
iad2     dw    0
iad3     dw    0
ida0     dw    0  ; local storage for d/a data
ida1     dw    0
ick0     dw    0  ; local data for counter data
ick1     dw    0
ick2     dw    0
idi0     dw    0  ; local data for digital input
ido0     dw    0  ; local data for digital output
nerr     dw    0  ; used for keyboard abort error
npsamp   dw    0
data     ends
dgroup   group     data,caandata
caanlib  segment 'code'
         assume cs:caanlib,ds:dgroup,ss:dgroup,es:nothing
public   setuca   ;(iadsta)
setuca   proc far
         frame
         grab iadsta,6
         mov caans,0
         regset iadsta
         unframe 4
setuca   endp
public   pc10ki
pc10ki   proc far
;  pc10ki(iarray,nsamp,icount) put nsamp*8 values from ch 0 into iarray
;                              speed is icount*.9775E-6,102<icount<255
         frame
         numport dev_num,num9
         xor ax,ax            ; mux channel to 0
         mov istat,ax
         numport ad_csr,istat
; set up the clock
         grab idatt1,6
         ratecntr idatt1,034H,cnt_csr,cnt_0
         ratecntr idatt1,074H,cnt_csr,cnt_1
; get nsamp - the number of paragraphs to take - each paragraph is 8 samples
         rgrab ax,10
         mov npsamp,ax
         les bx,dword ptr [bp+14] ; put address into es:[bx]
; ax - general use
; bx - part of array address
; cx - general use
; dx - for port i/o
; si - part of array address
; di - counts down number of groups of signals
; es - part of array address
; loop npsamp times
         mov di,npsamp
loop_p:
         mov si,0
; loop through this 8 times (si increments 2x each sample
loop_s:
loop_hi:
             mov dx,cnt_csr    ; wait for counter to be <= 10
             mov al,004H       ; read low byte only
             out dx,al
             mov dx,cnt_0
             in al,dx
             mov ah,al
             at_fix
             in al,dx
             cmp ah,15
             jg loop_hi
loop_lo:
             mov dx,cnt_csr    ; wait for counter to be > 10
             mov al,004H       ; read low byte only
             out dx,al
             mov dx,cnt_0
             in al,dx
             mov ah,al
             at_fix
             in al,dx
             cmp ah,15
             jl loop_lo
;
             mov dx,ad_csr     ; initiate sample
             mov al,1
             out dx,al
             mov al,0
             add dx,1
             out dx,al
             sub dx,1
loop_wait:
;
             in al,dx
             test al,1
             jne loop_wait
             mov al,0          ; must reset start bit
             out dx,al
             mov al,0
             add dx,1
             out dx,al
             mov dx,ad_data    ; now read the data
             in al,dx
             mov cl,al         ; this is the low byte
             add dx,1
             in al,dx
             mov ch,al         ; this is the high byte
             mov es:[bx+si],cx ; put the data to array
             inc si
             inc si
             cmp si,16
             jl loop_s
; done inner loop
         mov cx,es
         inc cx
         mov es,cx
         dec di
         jnz loop_p
         unframe 12
pc10ki   endp
public   pc10ko
pc10ko   proc far
;  pc10ko(iarray,nsamp,icount) put nsamp*8 values from iarray into d/a 0
;                              speed is icount*.9775E-6,102<icount<255
         frame
         numport dev_num,num9
         xor ax,ax            ; out channel to 0
         mov istat,ax
         numport da_csr,istat
; set up the clock
         grab idatt1,6
         ratecntr idatt1,034H,cnt_csr,cnt_0
         ratecntr idatt1,074H,cnt_csr,cnt_1
; get nsamp and divide by 8 to get number of paragraphs to be taken
         rgrab ax,10
         mov npsamp,ax
         les bx,dword ptr [bp+14] ; put address into es:[bx]
; ax - general use
; bx - part of array address
; cx - general use
; dx - for port i/o
; si - part of array address
; di - counts down number of groups of signals
; es - part of array address
; loop npsamp times
         mov di,npsamp
ooop_p:
         mov si,0
; loop through this 8 times (si increments 2x each sample
ooop_s:
ooop_hi:
             mov dx,cnt_csr    ; wait for counter to be <= 10
             mov al,004H       ; read low byte only
             out dx,al
             mov dx,cnt_0
             in al,dx
             mov ah,al
             at_fix
             in al,dx
             cmp ah,15
             jg ooop_hi
ooop_lo:
             mov dx,cnt_csr    ; wait for counter to be > 10
             mov al,004H       ; read low byte only
             out dx,al
             mov dx,cnt_0
             in al,dx
             mov ah,al
             at_fix
             in al,dx
             cmp ah,15
             jl ooop_lo
;
             mov cx,es:[bx+si] ; put the data to array
             numport da_data,cx

             inc si
             inc si
             cmp si,16
             jl ooop_s
; done inner loop
         mov cx,es
         inc cx
         mov es,cx
         dec di
         jnz ooop_p
         unframe 12
pc10ko   endp
public   pcatod     ;(istat,ivalue) Single Channel immediately
pcatod   proc far
         frame
         numport dev_num,num9
         grab istat,10
         atodimm istat,ad_csr,ad_data,ax
         rungrab ax,6
         unframe 8
pcatod   endp
;
public   pcdtoa      ;(istat,ivalue) single channel immediately
pcdtoa   proc far
         frame
         numport dev_num,num9
         grab istat,10
         grab ivalue,6
         numport da_csr,istat
         numport da_data,ivalue
         unframe 8
pcdtoa   endp
public   pcadsc ; iadval
pcadsc   proc far
         frame
         numport dev_num,num9
         les bx,dword ptr [bp+6] ; put address into es:[bx]
         mov istat,0000H ; channel 0
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         mov istat,0100H ; channel 1
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         mov istat,0200H ; channel 2
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         mov istat,0300H ; channel 3
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         unframe 4
pcadsc   endp
public   pcdasc ; iadval
pcdasc   proc far
         frame
         numport dev_num,num9
         les bx,dword ptr [bp+6]
         mov istat,0000H
         numport da_csr,istat
         mov ax,es:[bx]
         mov ivalue,ax
         numport da_data,ivalue
         inc bx
         inc bx
         mov istat,0100H
         numport da_csr,istat
         mov ax,es:[bx]
         mov ivalue,ax
         numport da_data,ivalue
         unframe 4
pcdasc   endp

public   pcadda ; iadval
pcadda   proc far
         frame
         numport dev_num,num9
         les bx,dword ptr [bp+10] ; put address into es:[bx]
         mov istat,0000H ; channel 0
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         mov istat,0100H ; channel 1
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         mov istat,0200H ; channel 2
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         inc bx
         inc bx
         mov istat,0300H ; channel 3
         atodimm istat,ad_csr,ad_data,ax
         mov es:[bx],ax
         les bx,dword ptr [bp+6]
         mov istat,0000H
         numport da_csr,istat
         mov ax,es:[bx]
         mov ivalue,ax
         numport da_data,ivalue
         inc bx
         inc bx
         mov istat,0100H
         numport da_csr,istat
         mov ax,es:[bx]
         mov ivalue,ax
         numport da_data,ivalue
         unframe 8
pcadda   endp
public   pcdgou    ;(ivalue) put value to digital output
pcdgou   proc far
         frame
         numport dev_num,num8
         grab ivalue,6
         numport dg_data,ivalue
         unframe 4
pcdgou   endp
public   pcdgin     ;(ivalue) get digital value
pcdgin   proc far
         frame
         numport dev_num,num8
         mov dx,dg_data
         in al,dx
         mov ah,al
         inc dx
         in al,dx
         xchg al,ah
         rungrab ax,6
         unframe 4
pcdgin   endp
public   watica   ;(ierr) wait for counter overflow
watica   proc far
         frame
         waitcntr 040H,cnt_csr,cnt_1
         ungrab nerr,6
         unframe 4
watica   endp
public   sttica   ;(idatt1,idatt2) set up pacer clock
sttica   proc far
         frame
         grab idatt1,10
         grab idatt2,6
         ratecntr idatt1,034H,cnt_csr,cnt_0  ; timer0
         ratecntr idatt2,074H,cnt_csr,cnt_1  ; timer1
         unframe 8
sttica   endp
public   rdtica   ;(ivalue)  return counter 1 value
rdtica   proc far
         frame
         readcntr 040H,ivalue,cnt_csr,cnt_1
         ungrab ivalue,6
         unframe 4
rdtica   endp
public   rdint    ;(ivalue) return the value of the interrupt flags
rdint    proc far
         frame
         portnum int_reg,ivalue
         mov ax,ivalue
         and ax,0010H
         rungrab ax,14
         mov ax,ivalue
         and ax,0020H
         rungrab ax,10
         mov ax,ivalue
         and ax,0040H
         rungrab ax,6
         unframe 12
rdint    endp
public   clint    ; clear the interrupts
clint    proc far
         frame
         mov ivalue,080H
         numport int_reg,ivalue
         unframe 0
clint    endp
public   seint    ;(ivalue) set the value of the interrupt register
seint    proc far
         frame
         grab ivalue,6
         numport int_reg,ivalue
         unframe 4
seint    endp
public   st8253   ;(icont,ictrl,icount)
st8253   proc far
         frame
         grab icont,14
         grabb ictrl,10
         grab icount,6
         mov ax,cnt_0
         cmp icont,0
         je stdone
         mov ax,cnt_1
         cmp icont,1
         je stdone
         mov ax,cnt_2
stdone:
         mov cdata,ax
         ratecntr icount,ictrl,cnt_csr,cdata
         unframe 12
st8253   endp
caanlib  ends
end
